.model  small
.code

start:
        call    save_ip
save_ip:
        pushf

        push    ax
        mov     ax, 'AX'
        push    ax
        call    prtreg          ; AX no longer saved

        push    bx
        mov     ax, 'BX'
        push    ax
        call    prtreg

        push    cx
        mov     ax, 'CX'
        push    ax
        call    prtreg

        push    dx
        mov     ax, 'DX'
        push    ax
        call    prtreg

        push    si
        mov     ax, 'SI'
        push    ax
        call    prtreg

        push    di
        mov     ax, 'DI'
        push    ax
        call    prtreg

        mov     ax, 'FL'
        push    ax
        call    prtreg          ; Consumes saved flags!

        push    bp
        mov     ax, 'BP'
        push    ax
        call    prtreg

        pop     ax              ; Saved IP
        sub     ax, 3           ; Adjust for call instruction
        push    ax
        mov     ax, 'IP'
        push    ax
        call    prtreg

        mov     ax, sp          ; Avoid 'PUSH SP' differences
        push    ax
        mov     ax, 'SP'
        push    ax
        call    prtreg

        push    cs
        mov     ax, 'CS'
        push    ax
        call    prtreg

        push    ds
        mov     ax, 'DS'
        push    ax
        call    prtreg

        push    es
        mov     ax, 'ES'
        push    ax
        call    prtreg

        push    ss
        mov     ax, 'SS'
        push    ax
        call    prtreg

stop:
        hlt
        jmp     stop

prtreg  proc
        push    bp
        mov     bp, sp
        push    ax

        mov     ax, [bp+4]      ; Register name on stack
        push    ax
        call    prtasc2

        mov     ax, ': '
        push    ax
        call    prtasc2

        mov     ax, [bp+6]      ; Register value on stack
        push    ax
        call    prth16

        mov     ax, 0D0Ah
        push    ax
        call    prtasc2

        pop     ax
        pop     bp
        ret     4
prtreg  endp

; Print a 16-bit hex number passed on the stack
prth16  proc
        push    bp
        mov     bp, sp
        push    ax
        mov     ax, [bp+4]
        push    cx
        mov     cx, 4
        push    bx
        push    dx
        mov     dx, cx
next_dig:
        push    ax
        xchg    ah, al
        shr     al, cl
        mov     ah, 0Eh
        and     al, 0Fh
        add     al, '0' ; Turn into a digit
        cmp     al, '9' ; Is it in 0-9 range?
        jle     digit
        add     al, 'A' - '0' - 10  ; Turn it into a letter in A-F range
digit:
        mov     bx, 1   ; BH = page number, BL = color in graphics modes
        int     10h
        pop     ax
        shl     ax, cl   ; Next nibble
        dec     dx
        jnz     next_dig

        pop     dx
        pop     bx
        pop     cx
        pop     ax
        pop     bp
        ret     2
prth16  endp

prtasc2 proc
        push    bp
        mov     bp, sp
        mov     al, [bp+5]
        push    ax
        push    bx

        mov     ah, 0Eh
        mov     bx, 1   ; BH = page number, BL = color in graphics modes
        int     10h

        mov     al, [bp+4]
        int     10h

        pop     bx
        pop     ax
        pop     bp
        ret     2
prtasc2 endp

end     start
